Attribute VB_Name = "modDirectoryServer"
Option Explicit

'Socket structures
Private SockAddy As sockaddr

'Packet filters
Private Enum O1_TYPES
 SessionData = 0
End Enum

Private Enum O2_TYPES
 SessionRequest = 1
 KeyNotify = 2
 ACKRequired = 3
 ACKMessage = 4
 SyncClient = 5
 SyncServer = 6
 Disconnect = 7
 PacketCluster = 14
End Enum

Private ServerListBuffer As String

Private Sub Handler02(UnencryptedPacket As String)
'UDPSend SockAddy, Chr(0) + Chr(3) + NextSID + GetString(1) + Chr(0)
'SendSync 1
UDPSend SockAddy, Packet03
UDPSend SockAddy, Packet05
    
frmServerList.AddStatus "Sent login packet"
If frmServerList.HaveDirectoryServer(frmServerList.cmbDirectoryServer) = 0 Then
 frmServerList.cmbDirectoryServer.AddItem frmServerList.cmbDirectoryServer
 frmServerList.cmbDirectoryServer.ListIndex = frmServerList.cmbDirectoryServer.NewIndex
End If
frmServerList.chkDownload.ForeColor = vbGreen
frmServerList.AddStatus "Downloading server list"
ServerListBuffer = ""
End Sub

Private Sub Handler03(UnencryptedPacket As String)
ServerListBuffer = ServerListBuffer + Mid(UnencryptedPacket, 13)

If Len(UnencryptedPacket) < 492 Then
 frmServerList.AddStatus "Done receiving the server list"
 frmServerList.AddStatus "Leaving"
 frmServerList.GenerateServerList ServerListBuffer
 frmServerList.chkDownload.Caption = "Download"
 frmServerList.chkDownload.ForeColor = vbButtonText
 Screen.MousePointer = vbDefault
 LeaveServer
 AutoDownloadEvent = "" 'Flag for the timer to start auto download again
End If
End Sub

Private Sub Handler06(UnencryptedPacket As String)
frmServerList.AddStatus "Sync packet accepted"
End Sub

Private Sub Handler07(UnencryptedPacket As String)
frmServerList.AddStatus "Disconnected by server"
Screen.MousePointer = vbDefault
frmServerList.chkDownload.ForeColor = vbRed
'frmserverlist.SSL.Enabled = False
AutoDownloadEvent = "" 'Flag for the timer to start auto download again
End Sub

Private Sub Handler0E(UnencryptedPacket As String)
On Error GoTo LeaveCluster
    
Dim i As Integer, O As String
    
O = Mid(UnencryptedPacket, 3)
Do
 i = Asc(Left(O, 1))
 HandleDirectoryServer SockAddy, Mid(O, 2, i)
 O = Mid(O, i + 2)
Loop
    
LeaveCluster:
End Sub

'Handler entry point
Public Sub HandleDirectoryServer(Sender As sockaddr, UnencryptedPacket As String)
SockAddy = Sender

Select Case Asc(Left(UnencryptedPacket, 1))
 Case O1_TYPES.SessionData
  Select Case Asc(Mid(UnencryptedPacket, 2, 1))
   Case O2_TYPES.KeyNotify: Handler02 UnencryptedPacket
   Case O2_TYPES.ACKRequired: Handler03 UnencryptedPacket
   Case O2_TYPES.SyncServer: Handler06 UnencryptedPacket
   Case O2_TYPES.Disconnect: Handler07 UnencryptedPacket
   Case O2_TYPES.PacketCluster: Handler0E UnencryptedPacket
   Case Else
    frmServerList.AddStatus "Error: unknown O2 packet #" + CStr(Asc(Mid(UnencryptedPacket, 2, 1)))
  End Select
 Case Else
  frmServerList.AddStatus "Error: unknown O1 packet #" + CStr(Asc(Left(UnencryptedPacket, 1)))
End Select
End Sub
